defstar {
	name { RunAve }
	domain { DDF }
	desc {
Running average some number of input samples or blocks of input samples.
Blocks of successive input samples are treated as vectors.
	}
	author { N. Becker }
	copyright {
Copyright (c) 1994 Neal Becker
	}
	location { DDF library }
	input {
		name { input }
		type { float }
	}
	output {
		name { output }
		type { float }
		num {0}
	}
	defstate {
		name { blockSize }
		type { int }
		default { 1 }
		desc {
Input blocks of this size will be averaged to produce an output block.
		}
	}
	defstate {
	  name { numAve }
		type { int }
		default { 1 }
		desc {
		  number of inputs to average.
		}
	}
	protected {
	  double *tmp;
	  int count;
	}
	constructor {
	  tmp = 0;
	}
	destructor {
	  delete[] tmp;
	}
	method {
	  name { init }
	  type { void }
	  code {
	    for( int i = 0; i < int(blockSize); i++ )
	      tmp[ i ] = 0;
	  }
	}

	setup {
		delete[] tmp;
		tmp = new double[ int(blockSize) ];
		input.setDDFParams( int(blockSize) );
		count = 0;
		init();
	}
	go {
	  input.receiveData();
	  for(int i=int(blockSize)-1; i >= 0; i-- ) {
	    tmp[ i ] += input%i;
	  }
	  count++;
	  if( count % int(numAve) == 0 ) {
	    for(int i=int(blockSize)-1; i >= 0; i-- ) {
	      output%0 << tmp[i]/double(int(numAve));
	      output.sendData();
	    }
	    init();
	  }
	}
}
